/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         geshdrparse
#define yylex           geshdrlex
#define yyerror         geshdrerror
#define yydebug         geshdrdebug
#define yynerrs         geshdrnerrs
#define yylval          geshdrlval
#define yychar          geshdrchar

/* First part of user prologue.  */
#line 7 "geshdr.y"

/*force le debugging du YACC                    */
#define lint    1
#ifdef	DEBUG
#define YYDEBUG 1
#endif

#include	<string.h>
#include	<stdio.h>
#include	<setjmp.h>
#include	<syslog.h>
#include	<stdlib.h>
#include	<unistd.h>

#include	"lowtyp.h"
#include	"utlvec.h"
#include	"bascnv.h"
#include	"subclm.h"
#include	"geshdr.h"

int yyparse();		/*syntax parser		*/
static int yylex();	/*lexical parser	*/

/*preamble static function declaration		*/
static int skipfor(char);
static void yyerror(char *);
static char *strmix(char *,char,char *);


#define	MXSTR	60	/*max line size in debug*/

typedef	enum	{	/*header type frame	*/
	hd_from,	/*From:			*/
	hd_to,		/*To:			*/
	hd_cc,		/*Cc:			*/
	hd_bcc,		/*Bcc:			*/
	hd_sender,	/*Sender: 		*/
	hd_replyto,	/*Reply-To: 		*/
	hd_inreplyto,	/*In-Reply-To: 		*/
	hd_references,	/*References: 		*/
	hd_receive,	/*Receive: 		*/
	hd_received_spf,/*Received-SPF:		*/
	hd_msgid,	/*Message-ID:		*/
	hd_subject,	/*Subject:		*/
	hd_date		/*Date:			*/
	}HIDTYP;

typedef	struct	{
	HIDTYP field;	/*header field type	*/	
	union {
	  char *time;	/*header date		*/
	  char *address;/*From address		*/
	  char *subject;/*Subject		*/
	  char *receive;/*Receive from field	*/
	  char **maddr;	/*To address		*/
	  char *info;	/*generic		*/
	  }info;
	}HDRTYP;

static HDRTYP **yhdrs;	/*header collected info	*/
static int itsok;	/*parsing status	*/
static jmp_buf manystop;/*YACC fully lost	*/
static int cptstop=0;	/*stop received counting*/

static char **lines;	/*data-header pointer	*/
static int numline;	/*next char header line	*/
static int numrow;	/*next char header row	*/
static int curline;	/*cur char header line	*/
static u_int currow;	/*cur char header row	*/
static int nbrerr;	/*nombre d'erreur	*/
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate an header struct	*/
/*						*/
/************************************************/
static HDRTYP *dupheader(HIDTYP field,void *infos)

{
HDRTYP *header;

header=(HDRTYP *)calloc(1,sizeof(HDRTYP));
header->field=field;
if (infos!=(void *)0) {
  switch (field) {
    case (hd_from)		:
    case (hd_sender)		:
    case (hd_replyto)		:
    case (hd_date)		:
      header->info.address=strdup(infos);
      break;
    case (hd_msgid)		:
      header->info.address=strdup(infos);
      break;
    case (hd_received_spf)	:	//NO BREAK
    case (hd_receive)		:
      header->info.receive=strdup(infos);
      break;
    case (hd_to)		:
    case (hd_cc)		:
    case (hd_bcc)		:
    case (hd_references)	:
    case (hd_inreplyto)	:
      if (infos!=(void *)0) { /*always		*/
	char **replys;
        register int i;
 
	replys=(char **)0; 
        for (i=0;((char **)infos)[i]!=(char *)0;i++)
  	  replys=(char **)vec_addlstlst((void **)replys,(void *)strdup(((char **)infos)[i]));
        header->info.maddr=replys;
        }
      break;
    case (hd_subject)	:
      header->info.subject=strdup(infos);
      break;
    default		:
      (void) clm_alert(0,"geshdr.y,dupheader: Unexpected field (bug?)");
      break;
    }
  }
return header;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to create the memory space	*/
/*	for a header line			*/
/*						*/
/************************************************/
static HDRTYP *genheader(HIDTYP field,void *infos)

{
HDRTYP *header;

header=(HDRTYP *)calloc(1,sizeof(HDRTYP));
header->field=field;
switch (field) {
  case (hd_from)	:
  case (hd_sender)	:
  case (hd_replyto)	:
  case (hd_date)	:
    (void) clm_strtolower((char *)infos);
    header->info.address=(char *)infos;
    break;
  case (hd_msgid)	:
    header->info.address=(char *)infos;
    break;
  case (hd_received_spf):
  case (hd_receive)	:
    header->info.receive=(char *)infos;
    break;
  case (hd_to)		:
  case (hd_cc)		:
  case (hd_bcc)		:
  case (hd_references)	:
  case (hd_inreplyto)	:
    if (infos!=(char **)0) {
      register int i;

      for (i=0;((char **)infos)[i]!=(char *)0;i++)
        (void) clm_strtolower(((char **)infos)[i]);
      }
    header->info.maddr=(char **)infos;
    break;
  case (hd_subject)	:
    header->info.subject=(char *)infos;
    break;
  default		:
    (void) clm_alert(0,"geshdr.y,genheader: Unexpected field (bug?)");
    break;
  }
return header;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to add a header component to	*/
/*	the header list.			*/
/*						*/
/************************************************/
static HDRTYP **addhdrs(HDRTYP **chdrs,HDRTYP *header)

{
if (header!=(HDRTYP *)0) {
  chdrs=(HDRTYP **)vec_addlstlst((void **)chdrs,(void *)header);
  }
return chdrs;
}

#line 275 "geshdr.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int geshdrdebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    STOP = 258,                    /* STOP  */
    CRLF = 259,                    /* CRLF  */
    COLON = 260,                   /* COLON  */
    SEMICOL = 261,                 /* SEMICOL  */
    COMMA = 262,                   /* COMMA  */
    AT = 263,                      /* AT  */
    DOT = 264,                     /* DOT  */
    MINUS = 265,                   /* MINUS  */
    U_LINE = 266,                  /* U_LINE  */
    PLUS = 267,                    /* PLUS  */
    PARLEFT = 268,                 /* PARLEFT  */
    PARRIGHT = 269,                /* PARRIGHT  */
    BRKLEFT = 270,                 /* BRKLEFT  */
    BRKRIGHT = 271,                /* BRKRIGHT  */
    LESSTHAN = 272,                /* LESSTHAN  */
    GRTRTHAN = 273,                /* GRTRTHAN  */
    QUESTION = 274,                /* QUESTION  */
    DEBENCOD = 275,                /* DEBENCOD  */
    ENCODFIN = 276,                /* ENCODFIN  */
    PUNCT = 277,                   /* PUNCT  */
    DATE = 278,                    /* DATE  */
    RDATE = 279,                   /* RDATE  */
    FROM = 280,                    /* FROM  */
    SUBJECT = 281,                 /* SUBJECT  */
    REPLYTO = 282,                 /* REPLYTO  */
    INRPLYTO = 283,                /* INRPLYTO  */
    RFERENCE = 284,                /* RFERENCE  */
    RECEIVE = 285,                 /* RECEIVE  */
    RECEIVED_SPF = 286,            /* RECEIVED_SPF  */
    SENDER = 287,                  /* SENDER  */
    MSGID = 288,                   /* MSGID  */
    TO = 289,                      /* TO  */
    CC = 290,                      /* CC  */
    BCC = 291,                     /* BCC  */
    WORD = 292,                    /* WORD  */
    STRING = 293,                  /* STRING  */
    JAN = 294,                     /* JAN  */
    FEB = 295,                     /* FEB  */
    MAR = 296,                     /* MAR  */
    APR = 297,                     /* APR  */
    MAY = 298,                     /* MAY  */
    JUN = 299,                     /* JUN  */
    JUL = 300,                     /* JUL  */
    AUG = 301,                     /* AUG  */
    SEP = 302,                     /* SEP  */
    OCT = 303,                     /* OCT  */
    NOV = 304,                     /* NOV  */
    DEC = 305,                     /* DEC  */
    MON = 306,                     /* MON  */
    TUE = 307,                     /* TUE  */
    WED = 308,                     /* WED  */
    THU = 309,                     /* THU  */
    FRI = 310,                     /* FRI  */
    SAT = 311,                     /* SAT  */
    SUN = 312                      /* SUN  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 204 "geshdr.y"

	HDRTYP **hdrs;	/*full header parsed	*/
	HDRTYP *header;	/*one line header	*/
	char *string;	/*the info is a string	*/
	char punct;	/*one char only		*/
	char *word;	/*the info is a word	*/
	char *email;	/*the info is an E-mail	*/
	char **mboxs;	/*multiple Mail boxs	*/
	void *generic;	/*generic value		*/
	long time;	/*time value as a long	*/
	char *strtime;	/*time as a str(long)	*/
	int symbol;	/*token numeric value	*/
	long integer;	/*the value is integer	*/
	float floatting;/*the value is a float	*/
	

#line 396 "geshdr.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE geshdrlval;


int geshdrparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_STOP = 3,                       /* STOP  */
  YYSYMBOL_CRLF = 4,                       /* CRLF  */
  YYSYMBOL_COLON = 5,                      /* COLON  */
  YYSYMBOL_SEMICOL = 6,                    /* SEMICOL  */
  YYSYMBOL_COMMA = 7,                      /* COMMA  */
  YYSYMBOL_AT = 8,                         /* AT  */
  YYSYMBOL_DOT = 9,                        /* DOT  */
  YYSYMBOL_MINUS = 10,                     /* MINUS  */
  YYSYMBOL_U_LINE = 11,                    /* U_LINE  */
  YYSYMBOL_PLUS = 12,                      /* PLUS  */
  YYSYMBOL_PARLEFT = 13,                   /* PARLEFT  */
  YYSYMBOL_PARRIGHT = 14,                  /* PARRIGHT  */
  YYSYMBOL_BRKLEFT = 15,                   /* BRKLEFT  */
  YYSYMBOL_BRKRIGHT = 16,                  /* BRKRIGHT  */
  YYSYMBOL_LESSTHAN = 17,                  /* LESSTHAN  */
  YYSYMBOL_GRTRTHAN = 18,                  /* GRTRTHAN  */
  YYSYMBOL_QUESTION = 19,                  /* QUESTION  */
  YYSYMBOL_DEBENCOD = 20,                  /* DEBENCOD  */
  YYSYMBOL_ENCODFIN = 21,                  /* ENCODFIN  */
  YYSYMBOL_PUNCT = 22,                     /* PUNCT  */
  YYSYMBOL_DATE = 23,                      /* DATE  */
  YYSYMBOL_RDATE = 24,                     /* RDATE  */
  YYSYMBOL_FROM = 25,                      /* FROM  */
  YYSYMBOL_SUBJECT = 26,                   /* SUBJECT  */
  YYSYMBOL_REPLYTO = 27,                   /* REPLYTO  */
  YYSYMBOL_INRPLYTO = 28,                  /* INRPLYTO  */
  YYSYMBOL_RFERENCE = 29,                  /* RFERENCE  */
  YYSYMBOL_RECEIVE = 30,                   /* RECEIVE  */
  YYSYMBOL_RECEIVED_SPF = 31,              /* RECEIVED_SPF  */
  YYSYMBOL_SENDER = 32,                    /* SENDER  */
  YYSYMBOL_MSGID = 33,                     /* MSGID  */
  YYSYMBOL_TO = 34,                        /* TO  */
  YYSYMBOL_CC = 35,                        /* CC  */
  YYSYMBOL_BCC = 36,                       /* BCC  */
  YYSYMBOL_WORD = 37,                      /* WORD  */
  YYSYMBOL_STRING = 38,                    /* STRING  */
  YYSYMBOL_JAN = 39,                       /* JAN  */
  YYSYMBOL_FEB = 40,                       /* FEB  */
  YYSYMBOL_MAR = 41,                       /* MAR  */
  YYSYMBOL_APR = 42,                       /* APR  */
  YYSYMBOL_MAY = 43,                       /* MAY  */
  YYSYMBOL_JUN = 44,                       /* JUN  */
  YYSYMBOL_JUL = 45,                       /* JUL  */
  YYSYMBOL_AUG = 46,                       /* AUG  */
  YYSYMBOL_SEP = 47,                       /* SEP  */
  YYSYMBOL_OCT = 48,                       /* OCT  */
  YYSYMBOL_NOV = 49,                       /* NOV  */
  YYSYMBOL_DEC = 50,                       /* DEC  */
  YYSYMBOL_MON = 51,                       /* MON  */
  YYSYMBOL_TUE = 52,                       /* TUE  */
  YYSYMBOL_WED = 53,                       /* WED  */
  YYSYMBOL_THU = 54,                       /* THU  */
  YYSYMBOL_FRI = 55,                       /* FRI  */
  YYSYMBOL_SAT = 56,                       /* SAT  */
  YYSYMBOL_SUN = 57,                       /* SUN  */
  YYSYMBOL_YYACCEPT = 58,                  /* $accept  */
  YYSYMBOL_email = 59,                     /* email  */
  YYSYMBOL_headers = 60,                   /* headers  */
  YYSYMBOL_header = 61,                    /* header  */
  YYSYMBOL_data = 62,                      /* data  */
  YYSYMBOL_scrap = 63,                     /* scrap  */
  YYSYMBOL_originator = 64,                /* originator  */
  YYSYMBOL_senders = 65,                   /* senders  */
  YYSYMBOL_destination = 66,               /* destination  */
  YYSYMBOL_rcpts = 67,                     /* rcpts  */
  YYSYMBOL_bcc = 68,                       /* bcc  */
  YYSYMBOL_optionalfield = 69,             /* optionalfield  */
  YYSYMBOL_hmsgid = 70,                    /* hmsgid  */
  YYSYMBOL_inrplyto = 71,                  /* inrplyto  */
  YYSYMBOL_references = 72,                /* references  */
  YYSYMBOL_mulids = 73,                    /* mulids  */
  YYSYMBOL_msgids = 74,                    /* msgids  */
  YYSYMBOL_msgid = 75,                     /* msgid  */
  YYSYMBOL_dates = 76,                     /* dates  */
  YYSYMBOL_origdate = 77,                  /* origdate  */
  YYSYMBOL_resentdate = 78,                /* resentdate  */
  YYSYMBOL_datetime = 79,                  /* datetime  */
  YYSYMBOL_cachet = 80,                    /* cachet  */
  YYSYMBOL_date = 81,                      /* date  */
  YYSYMBOL_time = 82,                      /* time  */
  YYSYMBOL_hours = 83,                     /* hours  */
  YYSYMBOL_hour = 84,                      /* hour  */
  YYSYMBOL_sixty = 85,                     /* sixty  */
  YYSYMBOL_zone = 86,                      /* zone  */
  YYSYMBOL_optime = 87,                    /* optime  */
  YYSYMBOL_comments = 88,                  /* comments  */
  YYSYMBOL_comment = 89,                   /* comment  */
  YYSYMBOL_address = 90,                   /* address  */
  YYSYMBOL_group = 91,                     /* group  */
  YYSYMBOL_mailboxlist = 92,               /* mailboxlist  */
  YYSYMBOL_mailbox = 93,                   /* mailbox  */
  YYSYMBOL_addrspec = 94,                  /* addrspec  */
  YYSYMBOL_localpart = 95,                 /* localpart  */
  YYSYMBOL_locals = 96,                    /* locals  */
  YYSYMBOL_domain = 97,                    /* domain  */
  YYSYMBOL_subdomain = 98,                 /* subdomain  */
  YYSYMBOL_domainref = 99,                 /* domainref  */
  YYSYMBOL_domainliteral = 100,            /* domainliteral  */
  YYSYMBOL_dtext = 101,                    /* dtext  */
  YYSYMBOL_routeaddr = 102,                /* routeaddr  */
  YYSYMBOL_route = 103,                    /* route  */
  YYSYMBOL_words = 104,                    /* words  */
  YYSYMBOL_word = 105,                     /* word  */
  YYSYMBOL_encode = 106,                   /* encode  */
  YYSYMBOL_107_1 = 107,                    /* $@1  */
  YYSYMBOL_integer = 108,                  /* integer  */
  YYSYMBOL_atom = 109,                     /* atom  */
  YYSYMBOL_others = 110,                   /* others  */
  YYSYMBOL_punctuation = 111,              /* punctuation  */
  YYSYMBOL_marker = 112,                   /* marker  */
  YYSYMBOL_months = 113,                   /* months  */
  YYSYMBOL_days = 114,                     /* days  */
  YYSYMBOL_sign = 115                      /* sign  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  80
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   980

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  58
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  58
/* YYNRULES -- Number of rules.  */
#define YYNRULES  155
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  214

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   312


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   291,   291,   299,   305,   310,   317,   323,   327,   331,
     335,   339,   347,   357,   362,   363,   364,   372,   381,   385,
     389,   395,   401,   409,   413,   419,   425,   431,   437,   450,
     463,   469,   489,   495,   501,   507,   512,   517,   524,   533,
     538,   547,   552,   559,   574,   578,   584,   591,   597,   601,
     607,   612,   618,   632,   636,   640,   646,   650,   656,   666,
     676,   681,   720,   721,   725,   726,   729,   733,   741,   745,
     750,   755,   761,   767,   775,   783,   793,   797,   803,   808,
     815,   821,   827,   834,   842,   848,   854,   858,   877,   881,
     887,   891,   895,   901,   905,   911,   915,   919,   924,   932,
     940,   947,   968,   972,   976,   980,   987,   993,  1003,  1007,
    1011,  1026,  1030,  1037,  1036,  1069,  1089,  1093,  1100,  1104,
    1108,  1115,  1125,  1133,  1137,  1141,  1145,  1151,  1155,  1159,
    1163,  1167,  1171,  1175,  1181,  1185,  1189,  1193,  1197,  1201,
    1205,  1209,  1213,  1217,  1221,  1225,  1231,  1235,  1239,  1243,
    1247,  1251,  1255,  1261,  1265,  1269
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "STOP", "CRLF",
  "COLON", "SEMICOL", "COMMA", "AT", "DOT", "MINUS", "U_LINE", "PLUS",
  "PARLEFT", "PARRIGHT", "BRKLEFT", "BRKRIGHT", "LESSTHAN", "GRTRTHAN",
  "QUESTION", "DEBENCOD", "ENCODFIN", "PUNCT", "DATE", "RDATE", "FROM",
  "SUBJECT", "REPLYTO", "INRPLYTO", "RFERENCE", "RECEIVE", "RECEIVED_SPF",
  "SENDER", "MSGID", "TO", "CC", "BCC", "WORD", "STRING", "JAN", "FEB",
  "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC",
  "MON", "TUE", "WED", "THU", "FRI", "SAT", "SUN", "$accept", "email",
  "headers", "header", "data", "scrap", "originator", "senders",
  "destination", "rcpts", "bcc", "optionalfield", "hmsgid", "inrplyto",
  "references", "mulids", "msgids", "msgid", "dates", "origdate",
  "resentdate", "datetime", "cachet", "date", "time", "hours", "hour",
  "sixty", "zone", "optime", "comments", "comment", "address", "group",
  "mailboxlist", "mailbox", "addrspec", "localpart", "locals", "domain",
  "subdomain", "domainref", "domainliteral", "dtext", "routeaddr", "route",
  "words", "word", "encode", "$@1", "integer", "atom", "others",
  "punctuation", "marker", "months", "days", "sign", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-157)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-116)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     154,    19,  -157,  -157,  -157,  -157,  -157,  -157,  -157,    15,
      25,    33,    41,    60,    71,    73,    78,    89,    90,    91,
      94,    96,    99,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,    24,    97,  -157,    63,  -157,  -157,   692,
    -157,   692,   692,  -157,   836,   836,   836,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,    36,    36,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,   325,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,    85,   971,   492,
     740,    -9,  -157,  -157,  -157,  -157,  -157,  -157,    98,  -157,
      11,  -157,   788,  -157,  -157,  -157,  -157,   836,  -157,  -157,
    -157,  -157,  -157,    22,   921,   104,  -157,    88,   382,  -157,
      95,    17,   884,    -3,   114,  -157,    85,   268,   884,  -157,
     884,    74,  -157,  -157,   692,   544,  -157,   100,    62,   884,
    -157,  -157,   146,   152,  -157,    40,   153,  -157,  -157,   122,
     122,   122,  -157,    16,  -157,     9,  -157,   211,  -157,  -157,
    -157,   142,  -157,  -157,  -157,    57,   158,   884,  -157,  -157,
      75,  -157,  -157,  -157,  -157,  -157,   122,   148,  -157,  -157,
    -157,   147,  -157,   439,  -157,  -157,  -157,  -157,  -157,   157,
    -157,   644,  -157,  -157,   941,  -157,   122,  -157,   594,  -157,
    -157,  -157,  -157,  -157
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    16,   123,   126,   124,    14,    15,   125,   122,   127,
       0,   131,     0,   133,     0,     0,     0,     0,   132,     0,
     128,   129,   130,    11,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   147,   148,   149,   150,
     151,   152,   146,     0,     0,     4,     0,    12,     7,     0,
       8,    70,    70,    10,     0,    36,    36,     9,    44,    45,
      13,   118,   119,   121,   120,     3,     0,     0,    18,    31,
      20,    33,    34,    28,    29,    19,    32,    23,    24,    25,
       1,    16,     2,     5,     6,     0,   113,   127,   131,   133,
     132,   128,   129,   130,   116,   110,    17,    76,     0,    86,
      78,     0,    88,   112,   111,   117,    21,    69,    68,    74,
       0,    22,     0,    42,    26,    43,    27,    35,    37,    30,
     115,    46,    49,    51,     0,     0,    47,     0,     0,   104,
       0,     0,     0,     0,     0,    77,     0,     0,     0,    89,
     108,    79,   109,    81,     0,     0,    41,     0,     0,    86,
      38,   153,   154,    61,    50,    54,     0,    55,    58,     0,
       0,     0,   106,     0,   101,     0,    90,     0,    94,    95,
     103,     0,   105,   114,    80,     0,    83,    87,    75,    72,
      73,    39,    40,   155,    61,    53,     0,    63,    52,    48,
     100,     0,   107,     0,    97,    98,    96,   102,    71,    57,
      59,     0,    60,    99,     0,    91,     0,    67,     0,    64,
      66,    56,    62,    65
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -157,  -157,  -157,   124,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,   113,  -157,   -49,  -157,  -157,
    -157,   103,    13,  -157,  -157,  -157,  -157,   -31,    37,  -157,
    -157,     5,   162,  -157,    79,   -47,   -79,   -75,   -91,    82,
      32,  -157,  -156,  -157,   -74,  -157,   -40,   -98,  -157,  -157,
    -120,  -124,     0,  -157,  -157,   102,    18,  -157
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,   116,   117,   118,    57,    58,
      59,   121,   122,   123,   154,   155,   156,   199,   157,   202,
     208,   209,   106,   107,   108,   109,    97,    98,    99,   165,
     166,   167,   168,   191,   100,   132,   101,   102,   103,   134,
     124,   104,   105,    61,    62,    63,    64,   159
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      60,   139,    96,   158,   169,   114,   130,   190,    85,   140,
     131,   110,   110,   169,   192,   172,   145,   163,   193,   190,
      66,   149,    65,   135,    80,   137,   138,   143,    85,   142,
      67,   164,   151,   147,   152,   142,   143,   148,    68,   187,
     188,   149,   139,   196,    60,   133,    69,   177,   190,   142,
     151,   139,   152,   171,   115,   115,   115,   131,   163,   153,
     141,   -85,   174,   -85,   -85,    70,   200,    84,   150,   169,
     137,   138,   164,   120,   -85,   -85,    71,   184,    72,   139,
     182,   198,   144,    73,   125,   125,   200,    36,    37,    38,
      39,    40,    41,    42,    74,    75,    76,   178,    81,    77,
      82,    78,    85,   210,    79,   144,   162,     2,     3,     4,
     210,   161,   142,   170,     5,     6,     7,   115,   181,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,   173,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     1,   183,  -115,   186,   120,
     197,   201,   206,   203,     2,     3,     4,   193,    83,   119,
     126,     5,     6,     7,   189,   211,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,   185,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   194,   213,   111,   -93,   -93,   -93,   -93,   176,
     -93,     2,     3,     4,   180,   205,   160,     0,   -93,   -93,
       7,     0,     0,     8,    87,     0,    88,     0,    89,     0,
       0,     0,     0,    90,     0,    91,    92,    93,    94,   195,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,   175,
       0,     0,   -84,     0,   -84,   -84,     0,     0,     2,     3,
       4,     0,     0,   164,     0,   -84,   -84,     7,     0,     0,
       8,    87,     0,    88,     0,    89,     0,     0,     0,     0,
      90,     0,    91,    92,    93,    94,     0,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,   127,     0,     0,     0,
       0,     0,     0,   128,     0,     2,     3,     4,     0,     0,
       0,     0,     0,   129,     7,    86,     0,     8,    87,     0,
      88,     0,    89,     0,     0,     0,     0,    90,     0,    91,
      92,    93,    94,    95,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,   163,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     0,     0,   164,     0,     0,
       0,     7,     0,     0,     8,    87,     0,    88,     0,    89,
       0,     0,     0,     0,    90,     0,    91,    92,    93,    94,
       0,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
     204,     0,     0,     0,     0,     0,     0,     0,     0,     2,
       3,     4,     0,     0,   164,     0,     0,     0,     7,     0,
       0,     8,    87,     0,    88,     0,    89,     0,     0,     0,
       0,    90,     0,    91,    92,    93,    94,     0,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,  -108,     0,     0,
       0,     0,     2,     3,     4,     0,     0,     0,     0,  -108,
    -108,     7,    86,     0,     8,    87,     0,    88,     0,    89,
       0,     0,     0,     0,    90,     0,    91,    92,    93,    94,
    -108,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
     179,     0,     0,     0,     2,     3,     4,     0,     0,     0,
       0,    85,     0,     7,    86,     0,     8,    87,     0,    88,
       0,    89,     0,     0,     0,     0,    90,     0,    91,    92,
      93,    94,    95,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   207,     0,     2,     3,     4,     0,   212,     0,
       0,     0,     0,     7,    86,     0,     8,    87,     0,    88,
       0,    89,     0,     0,     0,     0,    90,     0,    91,    92,
      93,    94,     0,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   207,     0,     2,     3,     4,     0,     0,     0,
       0,     0,     0,     7,    86,     0,     8,    87,     0,    88,
       0,    89,     0,     0,     0,     0,    90,     0,    91,    92,
      93,    94,     0,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,     2,     3,     4,     0,     0,     0,     0,    85,
       0,     7,    86,     0,     8,    87,     0,    88,     0,    89,
       0,     0,     0,     0,    90,     0,    91,    92,    93,    94,
      95,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
       2,     3,     4,     0,     0,     0,     0,     0,     0,     7,
      86,     0,     8,    87,     0,    88,     0,    89,     0,     0,
       0,     0,    90,     0,    91,    92,    93,    94,    95,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,     2,     3,
       4,     0,     0,     0,     0,     0,   146,     7,    86,     0,
       8,    87,     0,    88,     0,    89,     0,     0,     0,     0,
      90,     0,    91,    92,    93,    94,     0,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,     2,     3,     4,     0,
       0,     0,     0,   112,     0,     7,     0,     0,     8,    87,
       0,    88,     0,    89,     0,     0,     0,     0,    90,     0,
      91,    92,    93,   113,     0,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,     2,     3,     4,     0,     0,     0,
       0,     0,     0,     7,    86,     0,     8,    87,     0,    88,
       0,    89,     0,     0,     0,     0,    90,     0,    91,    92,
      93,    94,     0,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   163,     0,     0,   -92,   -92,   -92,   -92,     0,
     -92,     0,     0,     0,     0,     0,   164,     0,   -92,   -92,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,   136,     0,     0,   -82,     0,   -82,   -82,   137,
     138
};

static const yytype_int16 yycheck[] =
{
       0,    99,    49,   123,   128,    54,    85,   163,    17,   100,
      85,    51,    52,   137,     5,    18,     5,     1,     9,   175,
       5,   112,     3,    97,     0,     8,     9,   101,    17,    38,
       5,    15,    10,   112,    12,    38,   110,   112,     5,   159,
     160,   132,   140,   167,    44,    85,     5,   138,   204,    38,
      10,   149,    12,   132,    54,    55,    56,   132,     1,    37,
     100,     4,   136,     6,     7,     5,   186,     4,   117,   193,
       8,     9,    15,    37,    17,    18,     5,    37,     5,   177,
      18,     6,     7,     5,    66,    67,   206,    51,    52,    53,
      54,    55,    56,    57,     5,     5,     5,   144,     1,     5,
       3,     5,    17,   201,     5,     7,    18,    10,    11,    12,
     208,     7,    38,    18,    17,    18,    19,   117,    18,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    21,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,     1,    10,     5,     5,    37,
      18,    13,     5,    16,    10,    11,    12,     9,    44,    56,
      67,    17,    18,    19,   161,   206,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,   155,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     1,   208,    52,     4,     5,     6,     7,   137,
       9,    10,    11,    12,   145,   193,   124,    -1,    17,    18,
      19,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    -1,
      -1,    -1,    -1,    32,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,     1,
      -1,    -1,     4,    -1,     6,     7,    -1,    -1,    10,    11,
      12,    -1,    -1,    15,    -1,    17,    18,    19,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    -1,    -1,    -1,    -1,
      32,    -1,    34,    35,    36,    37,    -1,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    -1,    22,    23,    -1,
      25,    -1,    27,    -1,    -1,    -1,    -1,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    11,    12,    -1,    -1,    15,    -1,    -1,
      -1,    19,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      -1,    -1,    -1,    -1,    32,    -1,    34,    35,    36,    37,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      11,    12,    -1,    -1,    15,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    -1,    -1,    -1,
      -1,    32,    -1,    34,    35,    36,    37,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,     5,    -1,    -1,
      -1,    -1,    10,    11,    12,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    -1,    22,    23,    -1,    25,    -1,    27,
      -1,    -1,    -1,    -1,    32,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
       6,    -1,    -1,    -1,    10,    11,    12,    -1,    -1,    -1,
      -1,    17,    -1,    19,    20,    -1,    22,    23,    -1,    25,
      -1,    27,    -1,    -1,    -1,    -1,    32,    -1,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     8,    -1,    10,    11,    12,    -1,    14,    -1,
      -1,    -1,    -1,    19,    20,    -1,    22,    23,    -1,    25,
      -1,    27,    -1,    -1,    -1,    -1,    32,    -1,    34,    35,
      36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     8,    -1,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    -1,    22,    23,    -1,    25,
      -1,    27,    -1,    -1,    -1,    -1,    32,    -1,    34,    35,
      36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    10,    11,    12,    -1,    -1,    -1,    -1,    17,
      -1,    19,    20,    -1,    22,    23,    -1,    25,    -1,    27,
      -1,    -1,    -1,    -1,    32,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    -1,    22,    23,    -1,    25,    -1,    27,    -1,    -1,
      -1,    -1,    32,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    -1,
      22,    23,    -1,    25,    -1,    27,    -1,    -1,    -1,    -1,
      32,    -1,    34,    35,    36,    37,    -1,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    10,    11,    12,    -1,
      -1,    -1,    -1,    17,    -1,    19,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    -1,    -1,    -1,    -1,    32,    -1,
      34,    35,    36,    37,    -1,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    -1,    22,    23,    -1,    25,
      -1,    27,    -1,    -1,    -1,    -1,    32,    -1,    34,    35,
      36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     1,    -1,    -1,     4,     5,     6,     7,    -1,
       9,    -1,    -1,    -1,    -1,    -1,    15,    -1,    17,    18,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,     1,    -1,    -1,     4,    -1,     6,     7,     8,
       9
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     1,    10,    11,    12,    17,    18,    19,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    76,    77,    78,
     110,   111,   112,   113,   114,     3,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       0,     1,     3,    61,     4,    17,    20,    23,    25,    27,
      32,    34,    35,    36,    37,    38,    93,    94,    95,    96,
     102,   104,   105,   106,   109,   110,    90,    91,    92,    93,
     104,    90,    17,    37,    75,   110,    73,    74,    75,    73,
      37,    79,    80,    81,   108,   114,    79,     1,     8,    18,
      94,    95,   103,   104,   107,   102,     1,     8,     9,   105,
      96,   104,    38,   102,     7,     5,    18,    94,    95,    96,
      75,    10,    12,    37,    82,    83,    84,    86,   108,   115,
     113,     7,    18,     1,    15,    97,    98,    99,   100,   109,
      18,    94,    18,    21,   102,     1,    97,    96,    93,     6,
      92,    18,    18,    10,    37,    86,     5,   108,   108,    80,
     100,   101,     5,     9,     1,    38,   109,    18,     6,    85,
     108,    13,    87,    16,     1,    98,     5,     8,    88,    89,
     105,    85,    14,    89
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    58,    59,    59,    60,    60,    61,    62,    62,    62,
      62,    62,    62,    63,    63,    63,    63,    64,    65,    65,
      65,    66,    66,    67,    67,    68,    69,    69,    69,    69,
      69,    69,    70,    71,    72,    73,    73,    74,    74,    75,
      75,    75,    75,    75,    76,    76,    77,    78,    79,    79,
      80,    80,    81,    82,    82,    82,    83,    83,    84,    85,
      86,    86,    87,    87,    88,    88,    89,    89,    90,    90,
      90,    91,    91,    91,    92,    92,    93,    93,    93,    93,
      93,    93,    93,    94,    94,    94,    95,    95,    96,    96,
      97,    97,    97,    98,    98,    99,    99,    99,    99,   100,
     100,   101,   102,   102,   102,   102,   102,   103,   104,   104,
     104,   105,   105,   107,   106,   108,   109,   109,   110,   110,
     110,   110,   111,   111,   111,   111,   111,   112,   112,   112,
     112,   112,   112,   112,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   114,   114,   114,   114,
     114,   114,   114,   115,   115,   115
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     0,     1,     2,     3,
       3,     2,     1,     1,     1,     1,     3,     3,     3,     1,
       2,     1,     3,     2,     1,     1,     5,     3,     1,     1,
       3,     1,     3,     0,     1,     2,     1,     1,     1,     1,
       0,     4,     3,     3,     1,     3,     1,     2,     1,     2,
       3,     2,     1,     3,     2,     3,     1,     3,     1,     2,
       1,     3,     3,     1,     1,     1,     2,     2,     2,     3,
       2,     0,     4,     3,     2,     3,     3,     3,     1,     2,
       1,     1,     1,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* email: headers STOP  */
#line 292 "geshdr.y"
                        {
			yhdrs=(yyvsp[-1].hdrs);
                        if (itsok==true)
                          YYACCEPT;
                        else
                          YYABORT;
			}
#line 1817 "geshdr.c"
    break;

  case 3: /* email: error STOP  */
#line 300 "geshdr.y"
                        {
			YYABORT;
			}
#line 1825 "geshdr.c"
    break;

  case 4: /* headers: header  */
#line 306 "geshdr.y"
                        {
			(yyval.hdrs)=addhdrs((HDRTYP **)0,(yyvsp[0].header));
			yhdrs=(yyval.hdrs);
			}
#line 1834 "geshdr.c"
    break;

  case 5: /* headers: headers header  */
#line 311 "geshdr.y"
                        {
			(yyval.hdrs)=addhdrs((yyvsp[-1].hdrs),(yyvsp[0].header));
			yhdrs=(yyval.hdrs);
			}
#line 1843 "geshdr.c"
    break;

  case 6: /* header: data CRLF  */
#line 318 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[-1].header);
			}
#line 1851 "geshdr.c"
    break;

  case 7: /* data: originator  */
#line 324 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[0].header);
			}
#line 1859 "geshdr.c"
    break;

  case 8: /* data: destination  */
#line 328 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[0].header);
			}
#line 1867 "geshdr.c"
    break;

  case 9: /* data: dates  */
#line 332 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[0].header);
			}
#line 1875 "geshdr.c"
    break;

  case 10: /* data: optionalfield  */
#line 336 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[0].header);
			}
#line 1883 "geshdr.c"
    break;

  case 11: /* data: WORD  */
#line 340 "geshdr.y"
                        {
			(void) free((yyvsp[0].word));
			(yyval.header)=(HDRTYP *)0;
			if (numrow>0)
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			}
#line 1895 "geshdr.c"
    break;

  case 12: /* data: scrap  */
#line 348 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if (numrow>0)
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			(void) clm_alert(2,"header error!");
			}
#line 1907 "geshdr.c"
    break;

  case 13: /* scrap: others  */
#line 358 "geshdr.y"
                        {
			if ((yyvsp[0].word)!=(char *)0)
			  (void) free((yyvsp[0].word));
			}
#line 1916 "geshdr.c"
    break;

  case 17: /* originator: senders mailbox  */
#line 373 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if ((yyvsp[0].email)!=(char *)0) {
			  (yyval.header)=genheader((yyvsp[-1].integer),(yyvsp[0].generic));
			  }
			}
#line 1927 "geshdr.c"
    break;

  case 18: /* senders: FROM COLON  */
#line 382 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_from;
			}
#line 1935 "geshdr.c"
    break;

  case 19: /* senders: SENDER COLON  */
#line 386 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_sender;
			}
#line 1943 "geshdr.c"
    break;

  case 20: /* senders: REPLYTO COLON  */
#line 390 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_replyto;
			}
#line 1951 "geshdr.c"
    break;

  case 21: /* destination: rcpts address  */
#line 396 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if ((yyvsp[0].mboxs)!=(char **)0) 
			  (yyval.header)=genheader((yyvsp[-1].integer),(yyvsp[0].generic));
			}
#line 1961 "geshdr.c"
    break;

  case 22: /* destination: bcc address  */
#line 402 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if ((yyvsp[0].mboxs)!=(char **)0)
			  (yyval.header)=genheader((yyvsp[-1].integer),(yyvsp[0].generic));
			}
#line 1971 "geshdr.c"
    break;

  case 23: /* rcpts: TO COLON  */
#line 410 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_to;
			}
#line 1979 "geshdr.c"
    break;

  case 24: /* rcpts: CC COLON  */
#line 414 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_cc;
			}
#line 1987 "geshdr.c"
    break;

  case 25: /* bcc: BCC COLON  */
#line 420 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_bcc;
			}
#line 1995 "geshdr.c"
    break;

  case 26: /* optionalfield: hmsgid msgid  */
#line 426 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if ((yyvsp[0].mboxs)!=(char **)0)
			  (yyval.header)=genheader((yyvsp[-1].integer),(yyvsp[0].generic));
			}
#line 2005 "geshdr.c"
    break;

  case 27: /* optionalfield: inrplyto mulids  */
#line 432 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if ((yyvsp[0].mboxs)!=(char **)0)
			  (yyval.header)=genheader((yyvsp[-1].integer),(yyvsp[0].generic));
			}
#line 2015 "geshdr.c"
    break;

  case 28: /* optionalfield: RECEIVE COLON  */
#line 438 "geshdr.y"
                        {
			char *ptr;

			(yyval.header)=(HDRTYP *)0;
			ptr=strdup(&(lines[numline][numrow]));
			(void) clm_skipblank(ptr);
			(yyval.header)=genheader((int)hd_receive,(void *)ptr);
			if (lines[numline]!=(char *)0) {
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			  }
			}
#line 2032 "geshdr.c"
    break;

  case 29: /* optionalfield: RECEIVED_SPF COLON  */
#line 451 "geshdr.y"
                        {
			char *ptr;

			(yyval.header)=(HDRTYP *)0;
			ptr=strdup(&(lines[numline][numrow]));
			(void) clm_skipblank(ptr);
			(yyval.header)=genheader((int)hd_received_spf,(void *)ptr);
			if (lines[numline]!=(char *)0) {
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			  }
			}
#line 2049 "geshdr.c"
    break;

  case 30: /* optionalfield: references mulids  */
#line 464 "geshdr.y"
                        {
			(yyval.header)=(HDRTYP *)0;
			if ((yyvsp[0].mboxs)!=(char **)0)
			  (yyval.header)=genheader((yyvsp[-1].integer),(yyvsp[0].generic));
			}
#line 2059 "geshdr.c"
    break;

  case 31: /* optionalfield: SUBJECT COLON  */
#line 470 "geshdr.y"
                        {
			#define MXSUB	150

			char *ptr;

			(yyval.header)=(HDRTYP *)0;
			ptr=clm_skipblank(&(lines[numline][numrow]));
			ptr=cnv_mimequoted(ptr);
			if (strlen(ptr)>=MXSUB)
			  ptr[MXSUB-1]='\000';
			(yyval.header)=genheader((int)hd_subject,(void *)ptr);
			if (lines[numline]!=(char *)0) {
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			  }
			}
#line 2080 "geshdr.c"
    break;

  case 32: /* hmsgid: MSGID COLON  */
#line 490 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_msgid;
			}
#line 2088 "geshdr.c"
    break;

  case 33: /* inrplyto: INRPLYTO COLON  */
#line 496 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_inreplyto;
			}
#line 2096 "geshdr.c"
    break;

  case 34: /* references: RFERENCE COLON  */
#line 502 "geshdr.y"
                        {
			(yyval.integer)=(int)hd_references;
			}
#line 2104 "geshdr.c"
    break;

  case 35: /* mulids: msgids  */
#line 508 "geshdr.y"
                        {
			(yyval.mboxs)=(yyvsp[0].mboxs);
			}
#line 2112 "geshdr.c"
    break;

  case 36: /* mulids: %empty  */
#line 512 "geshdr.y"
                        {
			(yyval.mboxs)=(char **)0;
			}
#line 2120 "geshdr.c"
    break;

  case 37: /* msgids: msgid  */
#line 518 "geshdr.y"
                        {
			(yyval.mboxs)=(char **)0;
			if ((yyvsp[0].email)!=(char *)0)
  			  (yyval.mboxs)=(char **)vec_addlstlst((void **)0,
						            (void *)(yyvsp[0].email));
			}
#line 2131 "geshdr.c"
    break;

  case 38: /* msgids: msgids msgid  */
#line 525 "geshdr.y"
                        {
			(yyval.mboxs)=(yyvsp[-1].mboxs);
			if ((yyvsp[0].email)!=(char *)0)
  			  (yyval.mboxs)=(char **)vec_addlstlst((void **)(yyvsp[-1].mboxs),
						            (void *)(yyvsp[0].email));
			}
#line 2142 "geshdr.c"
    break;

  case 39: /* msgid: LESSTHAN addrspec GRTRTHAN  */
#line 534 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[-1].email);
			(void) skipfor('<');
			}
#line 2151 "geshdr.c"
    break;

  case 40: /* msgid: LESSTHAN localpart GRTRTHAN  */
#line 539 "geshdr.y"
                        {
			if ((yyvsp[-1].email)!=(char *)0) {
			  (void) free((yyvsp[-1].email));
			  (yyvsp[-1].email)=(char *)0;
			  }
			(yyval.email)=(yyvsp[-1].email);
			(void) skipfor('<');
			}
#line 2164 "geshdr.c"
    break;

  case 41: /* msgid: LESSTHAN GRTRTHAN  */
#line 548 "geshdr.y"
                        {
			(yyval.email)=(char *)0;
			(void) skipfor('<');
			}
#line 2173 "geshdr.c"
    break;

  case 42: /* msgid: WORD  */
#line 553 "geshdr.y"
                        {
			if ((yyvsp[0].word)!=(char *)0)
			  (void) free((yyvsp[0].word));
			(yyval.email)=(char *)0;
			(void) skipfor('<');
			}
#line 2184 "geshdr.c"
    break;

  case 43: /* msgid: others  */
#line 560 "geshdr.y"
                        {
			if ((yyvsp[0].word)!=(char *)0)
			  (void) free((yyvsp[0].word));
			(yyval.email)=(char *)0;
			(void) skipfor('<');
			}
#line 2195 "geshdr.c"
    break;

  case 44: /* dates: origdate  */
#line 575 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[0].header);
			}
#line 2203 "geshdr.c"
    break;

  case 45: /* dates: resentdate  */
#line 579 "geshdr.y"
                        {
			(yyval.header)=(yyvsp[0].header);
			}
#line 2211 "geshdr.c"
    break;

  case 46: /* origdate: DATE COLON datetime  */
#line 585 "geshdr.y"
                        {
			(yyval.header)=genheader(hd_date,(yyvsp[0].strtime));
			}
#line 2219 "geshdr.c"
    break;

  case 47: /* resentdate: RDATE COLON datetime  */
#line 592 "geshdr.y"
                        {
			(yyval.header)=genheader(hd_date,(yyvsp[0].strtime));
			}
#line 2227 "geshdr.c"
    break;

  case 48: /* datetime: days COMMA cachet  */
#line 598 "geshdr.y"
                        {
			(yyval.strtime)=(yyvsp[0].strtime);
			}
#line 2235 "geshdr.c"
    break;

  case 49: /* datetime: cachet  */
#line 602 "geshdr.y"
                        {
			(yyval.strtime)=(yyvsp[0].strtime);
			}
#line 2243 "geshdr.c"
    break;

  case 50: /* cachet: date time  */
#line 608 "geshdr.y"
                        {
		        (yyvsp[-1].integer)+=(yyvsp[0].integer);
			(void) asprintf(&((yyval.strtime)),"%ld",(yyvsp[-1].integer));
			}
#line 2252 "geshdr.c"
    break;

  case 51: /* cachet: date  */
#line 613 "geshdr.y"
                        {
			(void) asprintf(&((yyval.strtime)),"%ld",(yyvsp[0].integer));
			}
#line 2260 "geshdr.c"
    break;

  case 52: /* date: integer months integer  */
#line 619 "geshdr.y"
                        {
			struct tm timing;

			(void) memset(&timing,'\000',sizeof(timing));
			timing.tm_mday=(yyvsp[-2].integer);
			timing.tm_mon=(yyvsp[-1].integer);
	 		if ((yyvsp[0].integer)<100)
			  (yyvsp[0].integer)+=2000;
			timing.tm_year=(yyvsp[0].integer)-1900;
			(yyval.time)=timegm(&timing);
			}
#line 2276 "geshdr.c"
    break;

  case 53: /* time: hours zone  */
#line 633 "geshdr.y"
                        {
			(yyval.time)=(yyvsp[-1].time)-(yyvsp[0].time);
			}
#line 2284 "geshdr.c"
    break;

  case 54: /* time: hours  */
#line 637 "geshdr.y"
                        {
			(yyval.time)=(yyvsp[0].time);
			}
#line 2292 "geshdr.c"
    break;

  case 55: /* time: zone  */
#line 641 "geshdr.y"
                        {
			(yyval.time)=-(yyvsp[0].time);
			}
#line 2300 "geshdr.c"
    break;

  case 56: /* hours: hour COLON sixty COLON sixty  */
#line 647 "geshdr.y"
                        {
			(yyval.time)=((((yyvsp[-4].time)*60)+((yyvsp[-2].time)))*60)+(yyvsp[0].time);
			}
#line 2308 "geshdr.c"
    break;

  case 57: /* hours: hour COLON sixty  */
#line 651 "geshdr.y"
                        {
			(yyval.time)=(((yyvsp[-2].time)*60)+((yyvsp[0].time)))*60;
			}
#line 2316 "geshdr.c"
    break;

  case 58: /* hour: integer  */
#line 657 "geshdr.y"
                        {
			(yyval.time)=(yyvsp[0].integer);
			if ((yyvsp[0].integer)>24) {
			  (void) yyerror("Unexpected value (above 24 Hour)");
			  (yyval.time)=0;
			  } 
			}
#line 2328 "geshdr.c"
    break;

  case 59: /* sixty: integer  */
#line 667 "geshdr.y"
                        {
			(yyval.time)=(yyvsp[0].integer);
			if ((yyvsp[0].integer)>60) {
			  (void) yyerror("Unexpected value (above 60)");
			  (yyval.time)=0;
			  } 
			}
#line 2340 "geshdr.c"
    break;

  case 60: /* zone: sign integer optime  */
#line 677 "geshdr.y"
                        {
			(yyval.time)=(((yyvsp[-1].integer)/100)*3600)+(((yyvsp[-1].integer)%100)*60);
			(yyval.time)*=(yyvsp[-2].integer);
			}
#line 2349 "geshdr.c"
    break;

  case 61: /* zone: WORD  */
#line 682 "geshdr.y"
                        {
			static struct {
				char *zname;
				int diff;
				}tznom[]={
					  {"UTC",-0},
					  {"Z",-0},
					  {"GMT",-0},
					  {"EST",-5},
					  {"EDT",-4},
					  {"CST",-6},
					  {"CDT",-5},
					  {"MST",-7},
					  {"MDT",-6},
					  {"PST",-8},
					  {"PDT",-7},
					  {"AKST",-9},
					  {"AKDT",-8},
					  {"HST",-10},
					  {"HST",-10},
					  {"BST",+1},
					  {"CET",+1},
					  {"CST",+2},
					  {(char *)0,0}
					  };
			int i;

			(yyval.time)=0;
			for (i=0;tznom[i].zname!=(char *)0;i++) {
			  if (strcasecmp(tznom[i].zname,(yyvsp[0].word))==0) {
			    (yyval.time)=tznom[i].diff*3600;
			    break;
			    }
			  }	
			(void) free((yyvsp[0].word));
			}
#line 2390 "geshdr.c"
    break;

  case 66: /* comment: word  */
#line 730 "geshdr.y"
                        {
			(void) free((yyvsp[0].word));
			}
#line 2398 "geshdr.c"
    break;

  case 68: /* address: mailboxlist  */
#line 742 "geshdr.y"
                        {
			(yyval.mboxs)=(yyvsp[0].mboxs);
			}
#line 2406 "geshdr.c"
    break;

  case 69: /* address: group  */
#line 746 "geshdr.y"
                        {
			(yyval.mboxs)=(yyvsp[0].mboxs);
			}
#line 2414 "geshdr.c"
    break;

  case 70: /* address: %empty  */
#line 750 "geshdr.y"
                        {
			(yyval.mboxs)=(char **)0;
			}
#line 2422 "geshdr.c"
    break;

  case 71: /* group: words COLON mailboxlist SEMICOL  */
#line 756 "geshdr.y"
                        {
			if ((yyvsp[-3].word)!=(char *)0)
			  (void) free((yyvsp[-3].word));
			(yyval.mboxs)=(yyvsp[-1].mboxs);
			}
#line 2432 "geshdr.c"
    break;

  case 72: /* group: words COLON SEMICOL  */
#line 762 "geshdr.y"
                        {
			if ((yyvsp[-2].word)!=(char *)0)
			  (void) free((yyvsp[-2].word));
			(yyval.mboxs)=(char **)0;
			}
#line 2442 "geshdr.c"
    break;

  case 73: /* group: words COLON mailboxlist  */
#line 768 "geshdr.y"
                        {
			if ((yyvsp[-2].word)!=(char *)0)
			  (void) free((yyvsp[-2].word));
			(yyval.mboxs)=(yyvsp[0].mboxs);
			}
#line 2452 "geshdr.c"
    break;

  case 74: /* mailboxlist: mailbox  */
#line 776 "geshdr.y"
                        {
			(yyval.mboxs)=(char **)0;
			if ((yyvsp[0].email)!=(char *)0) {
  			  (yyval.mboxs)=(char **)vec_addlstlst((void **)0,
						            (void *)(yyvsp[0].email));
			  }
			}
#line 2464 "geshdr.c"
    break;

  case 75: /* mailboxlist: mailboxlist COMMA mailbox  */
#line 784 "geshdr.y"
                        {
			(yyval.mboxs)=(yyvsp[-2].mboxs);
			if ((yyvsp[-2].email)!=(char *)0) {
  			  (yyval.mboxs)=(char **)vec_addlstlst((void **)(yyvsp[-2].mboxs),
						            (void *)(yyvsp[0].email));
			  }
			}
#line 2476 "geshdr.c"
    break;

  case 76: /* mailbox: addrspec  */
#line 794 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2484 "geshdr.c"
    break;

  case 77: /* mailbox: addrspec routeaddr  */
#line 798 "geshdr.y"
                        {
			if ((yyvsp[-1].email)!=(char *)0)
			  (void) free((yyvsp[-1].email));
			(yyval.email)=(yyvsp[0].email);
			}
#line 2494 "geshdr.c"
    break;

  case 78: /* mailbox: routeaddr  */
#line 804 "geshdr.y"
                        {
			/*trapping common syntax error	*/
			(yyval.email)=(yyvsp[0].email);
			}
#line 2503 "geshdr.c"
    break;

  case 79: /* mailbox: routeaddr words  */
#line 809 "geshdr.y"
                        {
			/*trapping common syntax error	*/
			if ((yyvsp[0].email)!=(char *)0)
			  (void) free((yyvsp[0].email));
			(yyval.email)=(yyvsp[-1].email);
			}
#line 2514 "geshdr.c"
    break;

  case 80: /* mailbox: localpart error routeaddr  */
#line 816 "geshdr.y"
                        {
			if ((yyvsp[-2].email)!=(char *)0)
			  (void) free((yyvsp[-2].email));
			(yyval.email)=(yyvsp[0].email);
			}
#line 2524 "geshdr.c"
    break;

  case 81: /* mailbox: words routeaddr  */
#line 822 "geshdr.y"
                        {
			if ((yyvsp[-1].email)!=(char *)0)
			  (void) free((yyvsp[-1].email));
			(yyval.email)=(yyvsp[0].email);
			}
#line 2534 "geshdr.c"
    break;

  case 82: /* mailbox: localpart  */
#line 828 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2542 "geshdr.c"
    break;

  case 83: /* addrspec: localpart AT domain  */
#line 835 "geshdr.y"
                        {
			char *strloc;

			strloc=strmix((yyvsp[-2].email),'@',(yyvsp[0].email));
			(yyval.email)=strloc;
			}
#line 2553 "geshdr.c"
    break;

  case 84: /* addrspec: localpart AT  */
#line 843 "geshdr.y"
                        {
			if ((yyvsp[-1].word)!=(char *)0)
			  (void) free((yyvsp[-1].word));
			(yyval.word)=(char *)0;
			}
#line 2563 "geshdr.c"
    break;

  case 85: /* addrspec: localpart AT error  */
#line 849 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[-2].email);
			}
#line 2571 "geshdr.c"
    break;

  case 86: /* localpart: locals  */
#line 855 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2579 "geshdr.c"
    break;

  case 87: /* localpart: localpart DOT locals  */
#line 859 "geshdr.y"
                        {
			(yyval.email)=strmix((yyvsp[-2].email),'.',(yyvsp[0].word));
			}
#line 2587 "geshdr.c"
    break;

  case 88: /* locals: word  */
#line 878 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2595 "geshdr.c"
    break;

  case 89: /* locals: locals word  */
#line 882 "geshdr.y"
                        {
			(yyval.email)=strmix((yyvsp[-1].email),'\000',(yyvsp[0].word));
			}
#line 2603 "geshdr.c"
    break;

  case 90: /* domain: subdomain  */
#line 888 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2611 "geshdr.c"
    break;

  case 91: /* domain: domain DOT subdomain  */
#line 892 "geshdr.y"
                        {
			(yyval.email)=strmix((yyvsp[-2].email),'.',(yyvsp[0].email));
			}
#line 2619 "geshdr.c"
    break;

  case 92: /* domain: domain DOT error  */
#line 896 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[-2].email);
			}
#line 2627 "geshdr.c"
    break;

  case 93: /* subdomain: domainref  */
#line 902 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2635 "geshdr.c"
    break;

  case 94: /* subdomain: domainliteral  */
#line 906 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2643 "geshdr.c"
    break;

  case 95: /* domainref: atom  */
#line 912 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].word);
			}
#line 2651 "geshdr.c"
    break;

  case 96: /* domainref: domainref atom  */
#line 916 "geshdr.y"
                        {
			(yyval.email)=strmix((yyvsp[-1].email),'\000',(yyvsp[0].word));
			}
#line 2659 "geshdr.c"
    break;

  case 97: /* domainref: domainref error  */
#line 920 "geshdr.y"
                        {
			(void) yyerror("Unexpected character after domain reference");
			(yyval.email)=(yyvsp[-1].word);
			}
#line 2668 "geshdr.c"
    break;

  case 98: /* domainref: domainref STRING  */
#line 925 "geshdr.y"
                        {
			(void) yyerror("Unexpected string after domain reference");
			(yyvsp[0].word)=clm_freestr((yyvsp[0].word));
			(yyval.email)=(yyvsp[-1].word);
			}
#line 2678 "geshdr.c"
    break;

  case 99: /* domainliteral: BRKLEFT dtext BRKRIGHT  */
#line 933 "geshdr.y"
                        {
			(yyval.email)=(char *)0;
			if ((yyvsp[-1].word)!=(char *)0) {
			  (void) asprintf(&((yyval.email)),"[%s]",(yyvsp[-1].word));
			  (void) free((yyvsp[-1].word));
			  }
			}
#line 2690 "geshdr.c"
    break;

  case 100: /* domainliteral: error domainliteral  */
#line 941 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[0].email);
			}
#line 2698 "geshdr.c"
    break;

  case 101: /* dtext: %empty  */
#line 947 "geshdr.y"
                        {
			char *ptr;

			ptr=strdup(&(lines[numline][numrow]));
			(yyval.email)=ptr;
			while (*ptr!='\000') {
			  switch (*ptr) {
			    case ']'	:
			    case '['	:
			      *ptr='\000';
			      *(ptr+1)='\000';
			      break;
			    default	:
			      break;
			    }
			  ptr++;
			  }
			(void) skipfor(']');
			}
#line 2722 "geshdr.c"
    break;

  case 102: /* routeaddr: LESSTHAN route addrspec GRTRTHAN  */
#line 969 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[-1].email);
			}
#line 2730 "geshdr.c"
    break;

  case 103: /* routeaddr: LESSTHAN addrspec GRTRTHAN  */
#line 973 "geshdr.y"
                        {
			(yyval.email)=(yyvsp[-1].email);
			}
#line 2738 "geshdr.c"
    break;

  case 104: /* routeaddr: LESSTHAN GRTRTHAN  */
#line 977 "geshdr.y"
                        {
			(yyval.email)=(char *)0;
			}
#line 2746 "geshdr.c"
    break;

  case 105: /* routeaddr: LESSTHAN words GRTRTHAN  */
#line 981 "geshdr.y"
                        {
			if ((yyvsp[-1].word)!=(char *)0)
			  (void) free((yyvsp[-1].word));
			nbrerr++;
			(yyval.email)=(char *)0;
			}
#line 2757 "geshdr.c"
    break;

  case 106: /* routeaddr: LESSTHAN error GRTRTHAN  */
#line 988 "geshdr.y"
                        {
			(yyval.email)=(char *)0;
			}
#line 2765 "geshdr.c"
    break;

  case 107: /* route: AT domain COLON  */
#line 994 "geshdr.y"
                        {
			if ((yyvsp[-1].email)!=(char *)0)
			  (void) free((yyvsp[-1].word));
			}
#line 2774 "geshdr.c"
    break;

  case 108: /* words: locals  */
#line 1004 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2782 "geshdr.c"
    break;

  case 109: /* words: words STRING  */
#line 1008 "geshdr.y"
                        {
			(yyval.word)=strmix((yyvsp[-1].word),'\000',(yyvsp[0].word));
			}
#line 2790 "geshdr.c"
    break;

  case 110: /* words: STRING  */
#line 1012 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2798 "geshdr.c"
    break;

  case 111: /* word: atom  */
#line 1027 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2806 "geshdr.c"
    break;

  case 112: /* word: encode  */
#line 1031 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2814 "geshdr.c"
    break;

  case 113: /* $@1: %empty  */
#line 1037 "geshdr.y"
                        {	/*WAITING for end of encoding	*/
			int phase;
			int proceed;

			phase=0;
			proceed=true;
			while (skipfor('?')==true) {
			  switch (phase) {
			    case 0  :
			    case 1  :
			      phase++;
			      break;
			    case 2  :
			      if (lines[numline][numrow+1]!='=') {
			        nbrerr++;
			        (void) yyerror("Encoding syntax error");
				}
			      proceed=false;
			      break;
			    }
			  if (proceed==true)
			    numrow+=1;
			  else
			    break;
			  }
			}
#line 2845 "geshdr.c"
    break;

  case 114: /* encode: DEBENCOD $@1 ENCODFIN  */
#line 1064 "geshdr.y"
                        {
			(yyval.word)=(char *)0;
			}
#line 2853 "geshdr.c"
    break;

  case 115: /* integer: WORD  */
#line 1070 "geshdr.y"
                        {
			char *ptr;

			ptr=(yyvsp[0].word);
			(yyval.integer)=0;
        		if (strchr(ptr,'.')==(char *)0) {
			  long lval;

          		  if (sscanf(ptr,"%ld",&lval)==1) {
            		    (yyval.integer)=lval;
            		    }
          		  }
        		else {
			  (void) yyerror("Integer expected, found float");
			  }
			(void) free((yyvsp[0].word));
			}
#line 2875 "geshdr.c"
    break;

  case 116: /* atom: WORD  */
#line 1090 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2883 "geshdr.c"
    break;

  case 117: /* atom: others  */
#line 1094 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2891 "geshdr.c"
    break;

  case 118: /* others: punctuation  */
#line 1101 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2899 "geshdr.c"
    break;

  case 119: /* others: marker  */
#line 1105 "geshdr.y"
                        {
			(yyval.word)=(yyvsp[0].word);
			}
#line 2907 "geshdr.c"
    break;

  case 120: /* others: days  */
#line 1109 "geshdr.y"
                        {
		        static char *daylist[]={
		   		"Sun","Mon","Tue","Wed","Thu",
		   		"Fri","Sat"};
			(yyval.word)=strdup(daylist[(yyvsp[0].integer)]);
			}
#line 2918 "geshdr.c"
    break;

  case 121: /* others: months  */
#line 1116 "geshdr.y"
                        {
		        static char *monthlist[]={
				"Jan","Feb","Mar","Apr",
				"May","Jun","Jul","Aug",
		   		"Sep","Oct","Nov","Dec"};
			(yyval.word)=strdup(monthlist[(yyvsp[0].integer)]);
			}
#line 2930 "geshdr.c"
    break;

  case 122: /* punctuation: PUNCT  */
#line 1126 "geshdr.y"
                        {
			char strloc[10];

			(void) memset(strloc,'\000',sizeof(strloc));
			strloc[0]=(yyvsp[0].punct);
			(yyval.word)=strdup(strloc);
			}
#line 2942 "geshdr.c"
    break;

  case 123: /* punctuation: MINUS  */
#line 1134 "geshdr.y"
                        {
			(yyval.word)=strdup("-");
			}
#line 2950 "geshdr.c"
    break;

  case 124: /* punctuation: PLUS  */
#line 1138 "geshdr.y"
                        {
			(yyval.word)=strdup("+");
			}
#line 2958 "geshdr.c"
    break;

  case 125: /* punctuation: QUESTION  */
#line 1142 "geshdr.y"
                        {
			(yyval.word)=strdup("?");
			}
#line 2966 "geshdr.c"
    break;

  case 126: /* punctuation: U_LINE  */
#line 1146 "geshdr.y"
                        {
			(yyval.word)=strdup("_");
			}
#line 2974 "geshdr.c"
    break;

  case 127: /* marker: DATE  */
#line 1152 "geshdr.y"
                        {
			(yyval.word)=strdup("Date");
			}
#line 2982 "geshdr.c"
    break;

  case 128: /* marker: TO  */
#line 1156 "geshdr.y"
                        {
			(yyval.word)=strdup("To");
			}
#line 2990 "geshdr.c"
    break;

  case 129: /* marker: CC  */
#line 1160 "geshdr.y"
                        {
			(yyval.word)=strdup("Cc");
			}
#line 2998 "geshdr.c"
    break;

  case 130: /* marker: BCC  */
#line 1164 "geshdr.y"
                        {
			(yyval.word)=strdup("Bcc");
			}
#line 3006 "geshdr.c"
    break;

  case 131: /* marker: FROM  */
#line 1168 "geshdr.y"
                        {
			(yyval.word)=strdup("From");
			}
#line 3014 "geshdr.c"
    break;

  case 132: /* marker: SENDER  */
#line 1172 "geshdr.y"
                        {
			(yyval.word)=strdup("Sender");
			}
#line 3022 "geshdr.c"
    break;

  case 133: /* marker: REPLYTO  */
#line 1176 "geshdr.y"
                        {
			(yyval.word)=strdup("Reply-To");
			}
#line 3030 "geshdr.c"
    break;

  case 134: /* months: JAN  */
#line 1182 "geshdr.y"
                        {
			(yyval.integer)=0;
			}
#line 3038 "geshdr.c"
    break;

  case 135: /* months: FEB  */
#line 1186 "geshdr.y"
                        {
			(yyval.integer)=1;
			}
#line 3046 "geshdr.c"
    break;

  case 136: /* months: MAR  */
#line 1190 "geshdr.y"
                        {
			(yyval.integer)=2;
			}
#line 3054 "geshdr.c"
    break;

  case 137: /* months: APR  */
#line 1194 "geshdr.y"
                        {
			(yyval.integer)=3;
			}
#line 3062 "geshdr.c"
    break;

  case 138: /* months: MAY  */
#line 1198 "geshdr.y"
                        {
			(yyval.integer)=4;
			}
#line 3070 "geshdr.c"
    break;

  case 139: /* months: JUN  */
#line 1202 "geshdr.y"
                        {
			(yyval.integer)=5;
			}
#line 3078 "geshdr.c"
    break;

  case 140: /* months: JUL  */
#line 1206 "geshdr.y"
                        {
			(yyval.integer)=6;
			}
#line 3086 "geshdr.c"
    break;

  case 141: /* months: AUG  */
#line 1210 "geshdr.y"
                        {
			(yyval.integer)=7;
			}
#line 3094 "geshdr.c"
    break;

  case 142: /* months: SEP  */
#line 1214 "geshdr.y"
                        {
			(yyval.integer)=8;
			}
#line 3102 "geshdr.c"
    break;

  case 143: /* months: OCT  */
#line 1218 "geshdr.y"
                        {
			(yyval.integer)=9;
			}
#line 3110 "geshdr.c"
    break;

  case 144: /* months: NOV  */
#line 1222 "geshdr.y"
                        {
			(yyval.integer)=10;
			}
#line 3118 "geshdr.c"
    break;

  case 145: /* months: DEC  */
#line 1226 "geshdr.y"
                        {
			(yyval.integer)=11;
			}
#line 3126 "geshdr.c"
    break;

  case 146: /* days: SUN  */
#line 1232 "geshdr.y"
                        {
			(yyval.integer)=0;
			}
#line 3134 "geshdr.c"
    break;

  case 147: /* days: MON  */
#line 1236 "geshdr.y"
                        {
			(yyval.integer)=1;
			}
#line 3142 "geshdr.c"
    break;

  case 148: /* days: TUE  */
#line 1240 "geshdr.y"
                        {
			(yyval.integer)=2;
			}
#line 3150 "geshdr.c"
    break;

  case 149: /* days: WED  */
#line 1244 "geshdr.y"
                        {
			(yyval.integer)=3;
			}
#line 3158 "geshdr.c"
    break;

  case 150: /* days: THU  */
#line 1248 "geshdr.y"
                        {
			(yyval.integer)=4;
			}
#line 3166 "geshdr.c"
    break;

  case 151: /* days: FRI  */
#line 1252 "geshdr.y"
                        {
			(yyval.integer)=5;
			}
#line 3174 "geshdr.c"
    break;

  case 152: /* days: SAT  */
#line 1256 "geshdr.y"
                        {
			(yyval.integer)=6;
			}
#line 3182 "geshdr.c"
    break;

  case 153: /* sign: MINUS  */
#line 1262 "geshdr.y"
                        {
			(yyval.integer)=-1;
			}
#line 3190 "geshdr.c"
    break;

  case 154: /* sign: PLUS  */
#line 1266 "geshdr.y"
                        {
			(yyval.integer)=+1;
			}
#line 3198 "geshdr.c"
    break;

  case 155: /* sign: PLUS MINUS  */
#line 1270 "geshdr.y"
                        {
			(yyval.integer)=+1;
			}
#line 3206 "geshdr.c"
    break;


#line 3210 "geshdr.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1274 "geshdr.y"

#include	<memory.h>
#include	<ctype.h>
#include	<errno.h>

typedef	enum	{	/*email directive	*/
	mh_orgn,	/*E-mail physic origine	*/
	mh_from,	/*E-mail sender name	*/
	mh_rcpt,	/*E-mail recipient	*/
	mh_data		/*E-mail data phase	*/
	}MHTYP;

/*	Token list				*/
static struct	{
	int code;
	char *string;
	}vocable[]={	/*string MUST be in length order	*/
		   {RECEIVED_SPF,	"Received-SPF"},
		   {INRPLYTO,		"In-Reply-To"},
		   {RDATE,		"Resent-Date"},
		   {MSGID,		"Message-ID"},
		   {RFERENCE,		"References"},
		   {REPLYTO,		"Reply-To"},
		   {RECEIVE,		"Received"},
		   {SUBJECT,		"Subject"},
		   {SENDER,		"Sender"},
		   {DATE,		"Date"},
		   {FROM,		"From"},
		   {BCC,		"Bcc"},
		   {MON,"Mon"},{TUE,"Tue"},{WED,"Wed"},{THU,"Thu"},
		   {FRI,"Fri"},{SAT,"Sat"},{SUN,"Sun"},
		   {JAN,"Jan"},{FEB,"Feb"},{MAR,"Mar"},{APR,"Apr"},
		   {MAY,"May"},{JUN,"Jun"},{JUL,"Jul"},{AUG,"Aug"},
		   {SEP,"Sep"},{OCT,"Oct"},{NOV,"Nov"},{DEC,"Dec"},
		   {TO,			"To"},
		   {CC,			"Cc"},
		   {WORD,(char *)0}
		   };
/*

*/
/************************************************/
/*						*/
/*	Procedure to allocate a memory being	*/
/*	the contents of 2 memories, separated	*/
/*	by charactere (free the 2 previously	*/
/*	allocated memories)			*/
/*						*/
/************************************************/
static char *strmix(char *part1,char sep,char *part2)

{
char *mix;

mix=(char *)0;
if (part1==(char *)0)
  part1=strdup("");
if (part2==(char *)0)
  part2=strdup("");
if (sep!='\000') 
  (void) asprintf(&mix,"%s%c%s",part1,sep,part2);
else
  (void) asprintf(&mix,"%s%s",part1,part2);
(void) free(part2);
(void) free(part1);
return mix;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to really clean the YACC	*/
/*	satructure.				*/
/*						*/
/************************************************/
static void cleanyyparse()

{
#ifdef	YYINITSTACKSIZE
#if	YYPATCH >= 20100216
/*procedure already included byacc-1.9		*/
#else
/*to free yyparse dynamically allocated memory	*/
if (yyvs!=(YYSTYPE *)0) {
  (void) free(yyvs);
  yyvs=(YYSTYPE *)0;
  }
if (yyss!=(short *)0) {
  (void) free(yyss);
  yyss=(short *)0;
  }
yystacksize=0;
#endif
#endif
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to report a parsing error	*/
/*	debugging mode only.			*/
/*						*/
/************************************************/
static void yyerror(char *info)

{
int dbg;

dbg=0;
if ((clm_foreground==true)||(debug>=dbg)) {
  int i;
  char crlf[3];

  (void) strcpy(crlf,"");
  for (i=0;lines[curline][i]!='\000';i++)
    if (isspace(lines[curline][i])!=false)
      lines[curline][i]=' ';
  if (currow>=strlen(lines[curline]))
    (void) strcpy(crlf,"\r\n");
  (void) clm_alert(dbg,"% 6d %.*s",curline+1,currow+2,lines[curline]);
  (void) clm_alert(dbg,"%*s %*s%s",6,"",currow+1,"^",info);
  }
nbrerr++;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the punct char	*/
/*	value.					*/ 	
/*						*/
/************************************************/
static int punctchar(char c)

{
int code;

code=PUNCT;
switch (c) {
  case '\n'	:
    code=CRLF;
    break;
  case ':'	:
    code=COLON;
    break;
  case ';'	:
    code=SEMICOL;
    break;
  case ','	:
    code=COMMA;
    break;
  case '@'	:
    code=AT;
    break;
  case '.'	:
    code=DOT;
    break;
  case '-'	:
    code=MINUS;
    break;
  case '_'	:
    code=U_LINE;
    break;
  case '+'	:
    code=PLUS;
    break;
  case '('	:
    code=PARLEFT;
    break;
  case ')'	:
    code=PARRIGHT;
    break;
  case '['	:
    code=BRKLEFT;
    break;
  case ']'	:
    code=BRKRIGHT;
    break;
  case '<'	:
    code=LESSTHAN;
    break;
  case '>'	:
    code=GRTRTHAN;
    break;
  case '='	:
    code=PUNCT;
    if (numrow!=0) {
      if (lines[numline][numrow]=='?') {
        numrow++;
        code=DEBENCOD;
        }
      }
    break;
  case '?'	:
    code=QUESTION;
    if (numrow!=0) {
      if (lines[numline][numrow]=='=') {
        numrow++;
        code=ENCODFIN;
        }
      }
    break;
  default	:
    code=PUNCT;
    break;
  }
return code;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the token value 	*/
/*	from a string				*/
/*						*/
/************************************************/
static int tokenfromstr(char *strtoken,int *disp)

{
int token;
int i;

*disp=0;
token=WORD;
for (i=0;vocable[i].string!=(char *)0;i++) {
  *disp=strlen(vocable[i].string);
  if (strncasecmp(vocable[i].string,strtoken,*disp)==0) {
    token=vocable[i].code;
    break;
    }
  }
return token;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to backspace in the header	*/
/*	the data-header				*/
/*						*/
/************************************************/
static void backspace()

{
numline=curline;
numrow=currow;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get the next character from*/
/*	the data-header				*/
/*						*/
/************************************************/
static char getnextchar()

{
int c;

c=EOF;
if (lines[numline]!=(char *)0) {
  curline=numline;
  currow=numrow;
  if ((numrow==0)&&(debug>0)) {
    char *addstr;

    addstr="";
    if (strlen(lines[numline])>MXSTR)
      addstr="...";
    (void) clm_alert(9,"%6d line=<%.*s%s>",numline+1,MXSTR,lines[numline],addstr);
    }
  c=(int)lines[numline][numrow];
  if (c=='\000') {
    c='\n';
    numrow=0;
    numline++;
    }
  else
    numrow++;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to synchronize on  a special	*/
/*	character within the line parsed line.	*/
/*						*/
/************************************************/
static int skipfor(char expected)

{
int found;

found=false;
while (lines[numline][numrow]!='\000') {
  if (lines[numline][numrow]==expected) {
    found=true;
    break;
    }
  numrow++;
  }
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a string on a line	*/
/*						*/
/************************************************/
static char *getstring()

{
#define STRINC  20

char c;
char *strloc;
int locnumline;
int locnumrow;

locnumline=numline;
locnumrow=numrow;
strloc=(char *)calloc(1,STRINC+5);
while ((c=getnextchar())!=EOF) {
  int bspace;
  char ajout[2];

  bspace=false;
  if ((strlen(strloc)%STRINC)==0) {
    strloc=(char *)realloc(strloc,(((strlen(strloc)/STRINC)+1)*STRINC)+5);
    }
  bspace=((strlen(strloc)>1)&&(strloc[strlen(strloc)]=='\\'));
  if ((c=='\n')&&(bspace==false)) {
    (void) free(strloc);
    strloc=(char *)0;
    numline=locnumline;
    numrow=locnumrow;
    break;
    }
  if ((c=='\"')&&(bspace==false))
    break;
  ajout[0]=c;
  (void) strncat(strloc,ajout,1);
  }
return strloc;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip comment in the header	*/
/*						*/
/************************************************/
static int skipcomment()

{
int c;
int proceed;

proceed=true;
c='(';
while (proceed==true) {
  proceed=false;
  c=getnextchar();
  if (c=='(')
    c=skipcomment(); 
  switch(c) {
    case ')'	:
      c=getnextchar();
      break;
    case '\n'	:
    case EOF	:
      (void) yyerror("')' expected ");
      break;
    default	:
      proceed=true;
      break;
    }
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip all blank character	*/
/*						*/
/************************************************/
static int skipblank()

{
int c;
int proceed;

c=EOF;
proceed=true;
while (proceed==true) {
  c=getnextchar();
  while (c=='(') {
    c=skipcomment();
    }
  if (isblank(c)==false)
    proceed=false;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get/recognise a lexical	*/
/*	input.					*/
/*						*/
/************************************************/
static int yylex()

{
#define MXINFO	200

int found;
int c;
int proceed;
int phase;
int disp;
int numerique;
char info[MXINFO];

found=STOP;
phase=0;
proceed=true;
disp=0;
numerique=false;
(void) memset(info,'\000',sizeof(info));
c=skipblank();
if (c==EOF) {
  if (cptstop>0)
    (void) siglongjmp(manystop,1);
    cptstop++;
  return STOP;
  }
while (proceed==true) {
  switch (phase) {
    case     0	:	/*looking for strings	*/
      if (c=='\"') {
        if ((yylval.string=getstring())!=(char *)0) {
	  found=STRING;
	  proceed=false;
	  }
	}
      break;
    case     1	:	/* looking for punct	*/
      if (isalnum(c)==false) {
        found=punctchar(c);
	yylval.punct=(char)c;
	proceed=false;
	}
      break;
    case     2	:	/* looking for keyword	*/
      if ((found=tokenfromstr(lines[numline]+(numrow-1),&disp))!=WORD) {
	char *ptr;

	ptr=lines[numline]+(numrow-1)+disp;
	if (isalnum(*ptr)==false) {
	  numrow+=(disp-1);
	  proceed=false;
	  }
	}
      break;
    case     3	:	/*checking if word could be numeric	*/
      if (isdigit(c)!=false) 
	numerique=true;
      break;
    case     4	:	/*extracting word			*/
      {
      int extract;
      unsigned int inx;

      extract=true;
      inx=0;
      while (extract==true) {
        info[inx++]=c;
        if ((c=getnextchar())==EOF) {
          found=STOP;
	  if (cptstop>0)
	    (void) siglongjmp(manystop,1);
	  cptstop++;
	  extract=false;
	  break;
          }
        if (inx>=sizeof(info))
          extract=false;
        if (extract==false)
	  break;
        extract=((isalnum(c)!=false));
        if (numerique==true)
	  extract|=((c=='.')||(c=='-')||(c=='+'));
	}
      (void) backspace();
      }
      break;
    case     5	:	/* this an alphanumic word	*/
      yylval.word=strdup(info);
      found=WORD;
      proceed=false;
      break;
    default	:	/*safe guard			*/
      proceed=false;
      break;
    }
  phase++;
  }
#ifdef DEBUG
if (yydebug>0) {
  /*synchronizing yydebug output	*/
  (void) fflush(stdout);
  (void) fflush(stderr);
  }
#endif
(void) clm_alert(11,"return token (value='%d')",found);
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a HDRTYP ** structure			*/
/*						*/
/************************************************/
static HDRTYP **cleanhdr(HDRTYP **chdrs)

{
if (chdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;chdrs[i]!=(HDRTYP *)0;i++) {
    switch (chdrs[i]->field) {
      case (hd_from)		:
      case (hd_sender)		:
      case (hd_replyto)		:
      case (hd_msgid)		:
	chdrs[i]->info.address=clm_freestr(chdrs[i]->info.address);
	break;
      case (hd_cc)		:
      case (hd_bcc)		:
      case (hd_to)		:
      case (hd_inreplyto)	:
      case (hd_references)	:
        if (chdrs[i]->info.maddr!=(char **)0) {
	  int j;

	  for (j=0;chdrs[i]->info.maddr[j]!=(char *)0;j++) {
	    (void) free(chdrs[i]->info.maddr[j]);
	    }
          (void) free(chdrs[i]->info.maddr);
	  }
	break;
      case (hd_date)		:
	chdrs[i]->info.time=clm_freestr(chdrs[i]->info.time);
	break;
      case (hd_received_spf)	:
      case (hd_receive)		:
	chdrs[i]->info.receive=clm_freestr(chdrs[i]->info.receive);
	break;
      case (hd_subject)		:
	chdrs[i]->info.subject=clm_freestr(chdrs[i]->info.subject);
	break;
      default			:
        (void) clm_alert(0,"unievl.y,hdr_cleanhdr: Unexpected field (bug?)");
	break;
      }
    (void) free(chdrs[i]);
    }
  (void) free(chdrs);
  chdrs=(HDRTYP **)0;
  }
return chdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to trace the address part of	*/
/*	header contents				*/
/*						*/
/************************************************/
static void displayaddr(int lv,HDRTYP *hdr)

{
char *ptr;

switch(hdr->field) {
  case hd_to		:
    ptr="To";
    break;
  case hd_cc		:
    ptr="Cc";
    break;
  case hd_bcc		:
    ptr="Bcc";
    break;
  case hd_inreplyto	:
    ptr="In-Reply-To";
    break;
  case hd_references	:
    ptr="References";
    break;
  default		:
    ptr="(bug?)";
    break;
  }
if (hdr->info.maddr!=(char **)0) {
  int i;

  for (i=0;hdr->info.maddr[i]!=(char *)0;i++) 
    (void) clm_alert(lv,"E_%s: <%s>",ptr,hdr->info.maddr[i]);
  }
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to trace the wanted headers	*/
/*	contents, in the debug logs		*/
/*						*/
/************************************************/
static void tracehdr(int lv,HDRTYP **chdrs)

{
if (chdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;chdrs[i]!=(HDRTYP *)0;i++) {
    switch (chdrs[i]->field) {
      case (hd_from)		:
	(void) clm_alert(lv,"E_From: <%s>",chdrs[i]->info.address);
	break;
      case (hd_cc)		:
      case (hd_bcc)		:
      case (hd_to)		:
      case (hd_inreplyto)	:
      case (hd_references)	:
	(void) displayaddr(lv,chdrs[i]);
	break;
      case (hd_sender)		:
	(void) clm_alert(lv,"E_Sender: <%s>",chdrs[i]->info.address);
	break;
      case (hd_replyto)		:
	(void) clm_alert(lv,"E_Reply-To: <%s>",chdrs[i]->info.address);
	break;
      case (hd_msgid)		:
	(void) clm_alert(lv,"E_Message-ID: <%s>",chdrs[i]->info.address);
	break;
      case (hd_date)		:
	{
	char *ptr;
	time_t temps;

	temps=atol(chdrs[i]->info.time);	
	ptr=asctime(gmtime(&temps));
	ptr[strlen(ptr)-1]='\000';
	(void) clm_alert(lv,"E_Date: <%s>",ptr);
	}
	break;
      case (hd_received_spf)		:
	if (chdrs[i]->info.receive!=(char *)0) {/*always*/
	  char *addstr;

	  addstr="";
	  if (strlen(chdrs[i]->info.receive)>MXSTR)
	    addstr="...";
	  (void) clm_alert(lv,"E_Received-SPF: <%.*s%s>",
			       MXSTR,chdrs[i]->info.receive,addstr);
	  }
	break;
      case (hd_receive)		:
	if (chdrs[i]->info.receive!=(char *)0) {/*always*/
	  char *addstr;

	  addstr="";
	  if (strlen(chdrs[i]->info.receive)>MXSTR)
	    addstr="...";
	  (void) clm_alert(lv,"E_Receive: <%.*s%s>",
			       MXSTR,chdrs[i]->info.receive,addstr);
	  }
	break;
      case (hd_subject)		:
	(void) clm_alert(lv,"E_Subject: <%s>",chdrs[i]->info.subject);
	break;
      default			:
        (void) clm_alert(0,"unievl.c,evl_tracehdr: Unexpected field (bug?)");
	break;
      }
    }
  }
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to scan a header and locate	*/
/*	specific information			*/
/*						*/
/************************************************/
static HDRTYP **parsehdrs(char **data)

{
HDRTYP **hdrs;
int verybad;

verybad=false;
cptstop=0;
lines=data;
numline=0;
numrow=0;
itsok=true;
nbrerr=0;
#ifdef DEBUG
if (debug>11)	/*debugging all yacc analyze	*/
  yydebug=1;
#endif
if (sigsetjmp(manystop,true)==0)
  verybad=yyparse(); 
else {
  verybad=true;
  }
hdrs=yhdrs;
yhdrs=(HDRTYP **)0;
(void) cleanyyparse();
if (verybad==true)
  hdrs=cleanhdr(hdrs); 
return hdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to scan a header and remove	*/
/*	to be trashed memory if needed.		*/
/*						*/
/************************************************/
static HDRTYP **mkhdr(char **data)

{
#define	OPMK	"geshdr.y.c:mkhdr,"

HDRTYP **hdrs;
int phase;
int proceed;

hdrs=(HDRTYP **)0;
phase=0;
proceed=true;
while (proceed==true) {
  switch (phase) {
    case 0	:	/*open Garbage Collector*/
      break;
    case 1	:	/*parsing under GC	*/
      if ((hdrs=parsehdrs(data))==(HDRTYP **)0)
	phase++;	/*no need duplicat	*/
      break;
    case 2	:	/*dup hdrs without GC	*/
      if (hdrs!=(HDRTYP **)0)	{/*always	*/
	HDRTYP **clone;
	int i;

	clone=(HDRTYP **)0;
  	for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    	  HDRTYP *loc;

    	  loc=dupheader(hdrs[i]->field,hdrs[i]->info.info);
          clone=(HDRTYP **)vec_addlstlst((void **)clone,(void *)loc);
	  }
  	hdrs=cleanhdr(hdrs); 
  	hdrs=clone; 
    	}
      break;
    case 3	:	/*cleaning trash	*/
      break;
    default	:	/*SAFE Guard		*/
      proceed=false;
      break;
    }
  phase++;
  }
return hdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract ALL reference found*/
/*	available in the E-mail header.		*/
/*						*/
/************************************************/
static char **getallhdrinfo(HDRTYP **hdrs,HIDTYP field)

{
char **infos;

infos=(char **)0;
if (hdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    if (hdrs[i]->field==field) {
      switch (field) {
        case (hd_receive)	:
	  infos=(char **)vec_addlstlst((void **)infos,(void *)hdrs[i]->info.receive);
	  break;
  	default			:
    	  (void) clm_alert(0,"geshdr.y:getallhdrinfo, Unexpected field (bug?)");
	  break;
	}
      }
    }
  }
return infos;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a reference found	*/
/*	available in the E-mail header.		*/
/*						*/
/************************************************/
static void *gethdrinfo(HDRTYP **hdrs,HIDTYP field)

{
void *str;

str=(char *)0;
if (hdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    if (hdrs[i]->field==field) {
      switch (field) {
        case (hd_from)		:
        case (hd_sender)	:
        case (hd_replyto)	:
        case (hd_msgid)		:
          str=(void *)hdrs[i]->info.address;
	  break;
  	case (hd_date)		:
          str=(void *)hdrs[i]->info.time;
	  break;
  	case (hd_inreplyto)	:
  	case (hd_references)	:
          str=(void *)hdrs[i]->info.maddr;
	  break;
  	case (hd_to)		:
  	case (hd_cc)		:
  	case (hd_bcc)		:
          str=(void *)hdrs[i]->info.maddr;
	  break;
        case (hd_subject)	:
          str=(void *)hdrs[i]->info.subject;
	  break;
  	default			:
    	  (void) clm_alert(0,"geshdr.y:getallhdrinfo, Unexpected field (bug?)");
	  break;
	}
      break;
      }
    }
  }
return str;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to collect specific set of	*/
/*	headers.				*/
/*						*/
/************************************************/
static char **mklist(HDRTYP **hdrs,char **list,HIDTYP hid)

{
char **mptr;

if ((mptr=gethdrinfo(hdrs,hid))!=(char **)0) {
  int i;

  for (i=0;mptr[i]!=(char *)0;i++) {
    list=(char **)vec_addlstlst((void **)list,(void *)strdup(mptr[i]));
    }
  }
return list;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to normalize some E-mails	*/
/*	(generated by mailling list) such	*/
/*	address x.12.34@somewhere.com		*/
/*	is translated to x@somewhwere.com	*/
/*						*/
/************************************************/
static char *cleanreal(char *real)

{
if (real!=(char *)0) {
  char *ptr;

  if ((ptr=strchr(real,'.'))!=(char *)0) {
    char *dotptr;
    int skip;
    int proceed;

    dotptr=ptr;
    ptr++;
    skip=true;
    proceed=true;
    while (proceed==true) {
      switch (*ptr) {
        case '@'  	:
        case '\000'  	:
	  proceed=false;	/*do NOT break	*/
	  // fall through
        case '.'	:
	  if (skip==true) {
	    (void) strcpy(dotptr,ptr);
	    ptr=dotptr;
	    }
	  dotptr=ptr;
	  skip=true;
	  break;
	default		:
	  if (skip==true)
	    skip=(isdigit(*ptr)!=false);
	  break;
        }
      ptr++;
      }
    }
  }
return real;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to look at E-mail header	*/
/*	information and extract selected fields	*/
/*						*/
/************************************************/
static EVLTYP *lookhdrs(char *session,HDRTYP **hdrs)

{
EVLTYP *evl;
int phase;
int proceed;

evl=(EVLTYP *)calloc(1,sizeof(EVLTYP));
phase=0;
proceed=true;
while (proceed==true) {
  char *ptr;

  ptr=(char *)0;
  switch (phase) {
    case	 0  :	/*extracting "Sender"	*/
      if ((ptr=gethdrinfo(hdrs,hd_sender))!=(char *)0) {
	evl->org=org_sender;
        evl->realfrom=strdup(ptr);
	phase++;	/*getting MSG DATE	*/
	phase++;
        }
      break;
    case	 1  :	/*extracting "Reply-To"	*/
      if ((ptr=gethdrinfo(hdrs,hd_replyto))!=(char *)0) {
	evl->org=org_replyto;
        evl->realfrom=strdup(ptr);
	phase++;	/*getting MSG DATE	*/
        }
      break;
    case	 2  :	/*extracting "From"	*/
      if ((ptr=gethdrinfo(hdrs,hd_from))!=(char *)0) {
	evl->org=org_from;
        evl->realfrom=strdup(ptr);
        }
      break;
    case	 3  :	/*extracting MSG date	*/
      if ((ptr=gethdrinfo(hdrs,hd_date))!=(char *)0) {
        evl->cachet=(time_t)atol(ptr);
        }
      break;
    case	 4  :	/*extracting MSGID	*/
      if ((ptr=gethdrinfo(hdrs,hd_msgid))!=(char *)0) 
      	evl->msgid=strdup(ptr);
      else
        (void) asprintf(&(evl->msgid),"%s@empty.msgid",session);
      evl->msgid=clm_cleanstring(evl->msgid); 
      break;
    case	 5  :	/*extracting Subject	*/
      if ((ptr=gethdrinfo(hdrs,hd_subject))==(char *)0) 
	ptr="___UNSPECIFIED____";
      evl->subject=strdup(ptr);
      evl->subject=clm_cleanstring(evl->subject); 
      if (strlen(evl->subject)==0) {
  	(void) free(evl->subject);
	evl->subject=strdup("___EMPTY____");
	}
      break;
    case	 6  :	/*extracting In-Reply-To*/
      evl->inrplyto=mklist(hdrs,(char **)0,hd_inreplyto);
      evl->inrplyto=mklist(hdrs,evl->inrplyto,hd_references);
      break;
    case	 7  :	/*extracting To,Cc,Bcc	*/
      evl->distlist=mklist(hdrs,(char **)0,hd_to);
      evl->distlist=mklist(hdrs,evl->distlist,hd_cc);
      evl->distlist=mklist(hdrs,evl->distlist,hd_bcc);
      break;
    case	8  :	/*cleaning realfrom	*/
      evl->realfrom=cleanreal(evl->realfrom); 
      break;
    case	9  :	/*counting received	*/
      if (hdrs!=(HDRTYP **)0) { /*always	*/
	char **infos;

        if ((infos=getallhdrinfo(hdrs,hd_receive))!=(char **)0) {
	  register int i;
  
	  for (i=0;infos[i]!=(char *)0;i++);
	  evl->nbrreceived=i;
	  (void) free(infos);
	  }
	}
      break;
    default	    :	/*SAFE Guard		*/
      proceed=false;
      break;
    }
  phase++;
  }
return evl;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to build a E-mail header	*/
/*	list, by concatanating lines which start*/
/*	with a space (see RFC 2022)		*/
/*						*/
/************************************************/
char **mkyachdr(char **headers)

{
char **yachdr;

yachdr=(char **)0;
if (headers!=(char **)0) {
  int i;

  for (i=0;headers[i]!=(char *)0;i++) {
    char *ptr;

    ptr=strdup(headers[i]);
    while (headers[i+1]!=(char *)0) {
      if (isblank(headers[i+1][0])==0) {
	break;
	}
      i++;
      headers[i][0]=' '; /*to get rid of TAB	*/
      ptr=(char *)realloc(ptr,strlen(ptr)+strlen(headers[i])+4);
      (void) strcat(ptr,headers[i]);
      }
    yachdr=(char **)vec_addlstlst((void **)yachdr,(void *)ptr);
    }
  }
return yachdr;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to analyse the email header	*/
/*	part. looking for information as:	*/
/*	Sender:, Reply-To:, From:...		*/
/*						*/
/************************************************/
EVLTYP *hdr_parseheader(char *session,char **headers)

{
EVLTYP *evl;

evl=(EVLTYP *)0;
if (headers!=(char **)0) {
  HDRTYP **hdrs;
  char **yachdr;

  yachdr=mkyachdr(headers);
  if ((hdrs=mkhdr(yachdr))!=(HDRTYP **)0) {
    evl=lookhdrs(session,hdrs);
    evl->nbrerror=nbrerr;
    if (debug>=2)
      (void) tracehdr(2,hdrs);
    hdrs=cleanhdr(hdrs);
    }
  else {
    int i;

    (void) clm_alert(0,"%s fatal header parsing error (session=<%s>",
		       "geshdr.y:hdr_parsehdr,",session);
    for (i=0;headers[i]!=(char *)0;i++) {
      (void) clm_alert(0,"header[%d]=<%s>",i,headers[i]);
      }
    }
  (void) vec_freelstlst((void **)yachdr,VECFREE);
  }
return evl;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by an	*/
/*	E-mail info structure			*/
/*						*/
/************************************************/
EVLTYP *hdr_freeevl(EVLTYP *evl)

{
if (evl!=(EVLTYP *)0) {
  evl->spamlvl=clm_freestr(evl->spamlvl);
  evl->distlist=(char **)vec_freelstlst((void **)evl->distlist,VECFREE);
  evl->inrplyto=(char **)vec_freelstlst((void **)evl->inrplyto,VECFREE);
  evl->virname=clm_freestr(evl->virname);
  evl->subject=clm_freestr(evl->subject);
  evl->msgid=clm_freestr(evl->msgid);
  evl->realfrom=clm_freestr(evl->realfrom);
  (void) free(evl);
  evl=(EVLTYP *)0;
  }
return evl;
}


